/******************************************************************************\
* ping.c - Simple ping utility using SOCK_RAW
* 
* Original Author:  Matt Kropp Feb. 2000
*
* Uses sample code from Microsoft which I have modified
* to compile with LabWindows CVI.  Fixed several bugs and
* memory leaks in the original Microsoft code.
*
* Note:	Security settings in Windows NT/2000/XP will prevent
*		raw sockets from working for users without administrator access.
*		Should work fine for administrators and SYSTEM services.
\******************************************************************************/

#include "ping.h"
#include <ansi_c.h>
#include <utility.h>
#include <userint.h>
#include <cvirte.h>    /* Needed if linking in external compiler; harmless otherwise */


int main (int argc, char *argv[])
{
	int result, i, count, accum;
	
	if (InitCVIRTE (0, argv, 0) == 0)    /* Needed if linking in external compiler; harmless otherwise */
		return -1;    /* out of memory */

	SetStdioWindowOptions (20, 1, 0);

	
	for(i=0, accum=0, count=0; i<200; i++)
	{
		result = ping(	"localhost",	// host to ping (numeric or text)
						32,				// data size
						500				// timeout in milliseconds (values less than 500 are interpreted as 500)
					 );
				 
		if(result<0)
			printf("host not reached within timeout\n");
		else
		{
			printf("round trip time: %dmS\n", result);
			accum += result;
			count++;
		}
	}
	
	if(count)
		printf("\nAverage: %dmS  Count: %d  Missing: %d\n\n", accum/count, count, i-count);
		
	return 0;
}
